<?php
/*
Plugin Name: Bulk Articles Importer
Plugin URI: http://bestplrproducts.com/
Description: A mass text articles importer. Great for PLR or quickly uploading lots of posts.
Version: 9.0.1.1
Author: BestPLRProducts
Author URI: http://bestplrproducts.com/
Stable tag: 9.0.1.1
*/
// Define constants
define( 'TBP_GULP_DIR', plugins_url( '', __FILE__ ));
define( 'TBP_GULP_PATH', dirname( __FILE__) );
define( 'TBP_GULP_TMP', get_temp_dir() );
define( 'TBP_GULP_PLUGIN_NAME', 'Bulk Article Importer' );

add_action('admin_menu','bp_admin_menu');
add_action('admin_init','bp_admin_init');
//add_action('admin_head','bp_admin_head');

$pluginPath = WP_PLUGIN_URL.'/'.plugin_basename(dirname(__FILE__));
    function bp_admin_init() {
    require_once(ABSPATH . 'wp-admin/includes/admin.php');
    /*
     Temporary path defaults to WordPress's temp path, WP_TEMP_DIR, which may not be
     defined. If not defined, WordPress will then see if WP_CONTENT_DIR (wp-content)
     is writable. If it cannot write to wp-content, it will then try to write to the
     systemwide tmp dir. If that fails, usually in the case of an overly restrictive
     open_basedir directive, you will have to change the path below to one that is
     writable by the http process, and readable according to PHP's basedir directive
     All files written by this plugin are temporary and will automatically be removed
     after they are processed. Plugin will also only accept files ending in .zip, to
     prevent any executable code from being uploaded in the first place.
    */
    
    $tmpPath = get_temp_dir();
  }

function bp_admin_head() {
    wp_enqueue_script('bp_lib',TBP_GULP_DIR.'/js/lib.js', array( 'jquery', 'jquery-ui-core', 'jquery-ui-datepicker' ));
    wp_enqueue_script('jquery-ui-timepicker-addon',TBP_GULP_DIR.'/js/jquery-ui-timepicker-addon.js', array( 'jquery', 'jquery-ui-core', 'jquery-ui-datepicker', 'jquery-ui-slider' ));
  
  // styles
  wp_enqueue_style( 'datepickerstyles', TBP_GULP_DIR.'/js/jquery.ui.datepicker.css' );
  wp_enqueue_style( 'timepickerstyles', TBP_GULP_DIR.'/js/jquery-ui-timepicker-addon.css' );
  wp_enqueue_style( 'jqueryuiallstyles', 'http://ajax.googleapis.com/ajax/libs/jqueryui/1.9.2/themes/pepper-grinder/jquery-ui.css' );
}

function bp_admin_menu() {
    // Add new top level admin menu
  $menupg = add_menu_page(TBP_GULP_PLUGIN_NAME, TBP_GULP_PLUGIN_NAME, 'manage_options', 'import-articles', 'bp_plugin_admin');

  add_submenu_page(
        'import-articles',                 // parent slug
        'Imported Articles',             // page title
        'Imported Articles',             // sub-menu title
        'edit_posts',                 // capability
        'edit.php?post_type=importedarticle' // your menu menu slug
    );
  // Enqueues JS only on our page
  add_action( 'load-'.$menupg, 'bp_admin_head' );
}
function bp_plugin_admin() {
    // Print upload form
    if(isset($_FILES['zip'])) {
        bp_process_upload();
    }
    elseif(isset($_POST['zipfile'])) {
        prepare_bp_process_zip();
        //bp_process_zip();
    }
    else {
        bp_show_upload_form();
    }
}



add_filter( 'cron_schedules', function($schedules){$schedules['5min'] = array('interval' => 60,'display' => __('Every 5 Minutes'));return $schedules;}); 


register_activation_hook(__FILE__, 'import_activation_thing_activation');
function import_activation_thing_activation() {
  // удалим на всякий случай все такие же задачи cron, чтобы добавить новые с "чистого листа"
  // это может понадобиться, если до этого подключалась такая же задача неправильно (без проверки что она уже есть)
  wp_clear_scheduled_hook( 'do_import_articles_dodel' );

  // Проверим нет ли уже задачи с таким же хуком
  // этот пункт не нужен, потому что мы выше удалил все задачи...
  // if( ! wp_next_scheduled( 'my_hourly_event' ) ) 

  // добавим новую cron задачу
  //wp_schedule_event( time(), 'hourly', 'my_hourly_event');
  wp_schedule_event(time(), '5min', 'do_import_articles_dodel');
}

function prepare_bp_process_zip(){
  $new_post_id = wp_insert_post([
    'post_type'=>'importedarticle',
    'post_status'=>'publish',
    'post_title'=>basename($_POST['zipfile'])
  ]);
  update_post_meta($new_post_id, '_import_data', $_POST);
  update_post_meta($new_post_id, '_import_imported', 0);
  update_post_meta($new_post_id, '_import_to_import', $_POST['count_files']);
  // wp_redirect('edit.php?post_type=importedarticle');
  echo "<script>window.onload=function(){window.location = 'edit.php?post_type=importedarticle'}</script>";
}

add_action('do_import_articles_dodel', 'bp_process_zip');

function bp_get_post_type($num) {
  ?>
  <input type="hidden" name="post_type[<?php echo $num; ?>]" class="default_post_type" value="post">
  <?php
}

function tbp_retrieve_post_type() {
  ?>
  <select name="post_type[<?php echo $num; ?>]" class="default_post_type">
    <option value="post">Post</option>
    <option value="page">Page</option>
    <?php 
    $args=array(
      'public'   => true,
      '_builtin' => false
    ); 
    $output = 'names'; // names or objects, note names is the default
    $operator = 'and'; // 'and' or 'or'
    $post_types=get_post_types($args,$output,$operator); 
      foreach ($post_types  as $post_type ) { ?>
      <option value="<?php echo $post_type; ?>"><?php echo $post_type; ?></option>
    <?php
      }
    ?>
    </select>
  <?php
}

function bp_process_zip() {
    //$info_id = $args;
    $imports = array(
      'post_type' => 'importedarticle', // maybe not
      'posts_per_page'=>1,
      'meta_query' => array(
        array(
          'key' => '_import_imported',
          'compare' => '<',
          'value' => 'mt1.meta_value', // this will be treated as a string
          'type' => 'NUMERIC'
        ),
        // this is to force adding the needed JOIN clause
        array(
          'key' => '_import_to_import', 
          'compare' => 'EXISTS' 
        ),
        'relation' => 'AND'
      )
    );

    $imports = new WP_Query($imports);
    
    if(count($imports->posts)==0 || !isset($imports->posts[0])){
      // file_put_contents(__DIR__.'/data.dat', 'Все прпоало');  
      exit;
    }

    $info_id = $imports->posts[0]->ID;

    
    // die();

    $_data = get_post_meta($info_id, '_import_data', true);
    
    $_last_imported = intval(get_post_meta($info_id, '_import_imported', true));
    $_POST = $_data;
    //file_put_contents(__DIR__.'/data.dat', $info_id."\n".$_last_imported."\n".print_r($_POST, true));
    $zip = zip_open($_POST['zipfile']) or file_put_contents(__DIR__."/data.dat","could not reopen zip");
        
    // convert date/time to numbers
        $date = strtotime($_POST['start_date']);
        $time = strtotime($_POST['start_time']);
        $combined_date = date('Y-m-d',$date) . ' ' . date('H:i:s',$time);
        $next_post = mysql2date('U',$combined_date);
   
    $interval = $_POST['post_interval'] * 60 * 60;
    
    $num = 0;
    ?>
    <?php
    while($zip_entry = zip_read($zip)) {
        if($num<$_last_imported){
          $num++;
          //file_put_contents(__DIR__.'/data.dat', 'Skipped entry '.$num.' '.zip_entry_name($zip_entry));
          continue;
        }
        zip_entry_open($zip,$zip_entry);
        $zip_entry_size = zip_entry_filesize($zip_entry);
        $filename = zip_entry_name($zip_entry);
        //file_put_contents(__DIR__.'/data.dat',$zip_entry_size.' '.$zip_entry.' '.$filename);
        
        $ext = substr($filename, strrpos($filename, '.') + 1);
    
      if(strtolower($ext) != 'txt') {
          continue;
      }
        //try{
          //  $text = iconv("CP1252","UTF-8",zip_entry_read($zip_entry,$zip_entry_size));     
        //}catch(Exception $e){
            $text = mb_convert_encoding(zip_entry_read($zip_entry,$zip_entry_size), 'UTF-8');    
        //}
        //if($text===false)
          //  file_put_contents(__DIR__.'/data.dat','ERROR'); 
        
        $text = preg_split("[\n\r]",$text,2);
        
    // Set $data as array
        $data = Array();
        
    // post_status conditions
    switch($_POST['post_status']) {
            case 0:
                $data['post_status'] = 'publish';
                break;
            case 1:
                $data['post_status'] = 'draft';
                break;
            case 2:
                $data['post_status'] = 'publish';
                break;
            default:
                $data['post_status'] = 'error';
                break;
        }
        
        $data['post_type'] = 'post';
        $data['post_author'] = $_POST['default_author'];
        $data['post_category'] = array($_POST['default_category']);
        $data['post_title'] = wp_kses_post( $text[0] );
        $data['post_content'] = wp_kses_post( $text[1] );
        $data['post_date'] = date('Y-m-d H:i:s', $next_post);
        $data['post_date_gmt'] = get_gmt_from_date($data['post_date']);
        
        $error = wp_insert_post($data, true);
        if(is_wp_error($error)){
          $error_message = $error->get_error_message();
          add_post_meta($info_id, '_import_errors', '<strong>'.$filename.'</strong>: <em>'.$error_message.'</em>');
        }
        $imported = intval(get_post_meta($info_id, '_import_imported', true));
        $imported++;
        update_post_meta($info_id, '_import_imported', $imported);  
        
        zip_entry_close($zip_entry);
        if($num-$_last_imported>=100){
          zip_close($zip);
          exit;
        }
        $num++;
        $next_post += $interval;
    } //endwhile
    ?>  
    <?php
    zip_close($zip);
    unlink($_POST['zipfile']);
}



add_filter( 'posts_request', function( $sql ) {
  // remove single quotes around 'mt1.meta_value'
  return str_replace( "'mt1.meta_value'", "mt1.meta_value", $sql );
} );

function bp_process_upload() {
    global $tmpPath;
    if( empty( $tmpPath ) ) {
          $upload_dir = wp_upload_dir();
          $tmpPath = $upload_dir['path'];
        }
    global $wpdb;
    
    
    wp_enqueue_script('jquery');
    
    // grab the lists once so we're not hitting the database hundreds/thousands of times.
    $authors = wp_dropdown_users('echo=0&name=RPLCME');
    $categories = wp_dropdown_categories('echo=0&hide_empty=0&hierarchical=1&name=RPLCME');
    $statuses = '<select name="RPLCME" id="RPLCME"><option value="0">Scheduled</option><option value="1">Draft</option><option value="2">Publish</option></select>';
    if(!is_uploaded_file($_FILES['zip']['tmp_name'])) { echo "<PRE>"; print_r($_FILES); echo "</PRE>"; die("Upload failed?"); }
    
    $zipFile = $tmpPath . $_FILES['zip']['name'];
    move_uploaded_file($_FILES['zip']['tmp_name'], $zipFile);
    
    $zip = zip_open($zipFile);
    
    if(!$zip) {
        unlink($zipFile);
        die("Failed to open file. Is it really a ZIP file?");
    }
    $count_files = 0;
    while($zip_entry = zip_read($zip)):
      $count_files++;
    endwhile;
    zip_close($zip);
    ?>    
    <div class="wrap">
    <div id="icon-options-general" class="icon32"><br /></div>
        <h2><?php echo TBP_GULP_PLUGIN_NAME; ?></h2>
    <div id="poststuff" class="metabox-holder">
      <div id="post-body-content" class="">
        <div class="postbox">
        <h3 class="hndle"><span>How Do You Want The Articles To Be Imported?</span></h3>
        <div class="inside">         
        <form action="<?php echo $_SERVER['REQUEST_URI']?>" method="POST">            
          <table>                
           <tr>
                  <td colspan="3">Select the article import options. You can make all articles publish in one post or individually<br /></td>
                </tr>
           <tr>
            <td>Date/time to start posting</td>
            <td><input type="text" class="date_input" id="start_date" name="start_date" value="<?php echo date('d M Y');?>" /></td>
            <td><input type="text" class="time_input" id="start_time" name="start_time" value="<?php echo date('g:m A');?>" /></td>
          </tr>
          <tr>
            <td>Interval to post at (in hours)</td>
            <td colspan="2"><input type="text" name="post_interval" value="24" /></td>
          </tr>
          <tr>
            <td>Set all articles to this author</td>
            <td><?php echo str_replace("<select", "<select onchange='setAllAuthors()'", str_replace('RPLCME','default_author',$authors));?></td>
            <td></td>
          </tr>
          <tr>
            <td>Set all articles to this category</td>
            <td><?php echo str_replace("<select", "<select onchange='setAllCategories()'", str_replace('RPLCME','default_category',$categories))?></td>
            <td></td>
          </tr>
          <tr>
            <td>Set all articles to this status</td>
            <td>
                <select name="post_status">
                    <option value=0>Scheduled</option>
                    <option value=1>Draft</option>
                    <option value=2>Publish</option>
                </select>
            <!--<input type="button" onclick="setAllStatus(0);" value="Scheduled" />                    -->
            <!--<input type="button" onclick="setAllStatus(1);" value="Draft" />-->
            <!--<input type="button" onclick="setAllStatus(2);" value="Publish" />-->
            <!--<input type="hidden" name="post_status" value="0">-->
            </td>
          </tr>
        </table>                    
  <p>
          <input type="submit" class="button-primary" value="Process Articles" />
        </p>
  <input type="hidden" name="zipfile" value="<?php echo $zipFile?>" />       
  <input type="hidden" name="count_files" value="<?php echo $count_files?>" />        
</form>
        </div>
       </div>
    </div>
    </div>
    </div>
<?php
}
function bp_show_upload_form() {
        global $tmpPath;
        if( empty( $tmpPath ) ) {
          $upload_dir = wp_upload_dir();
          $tmpPath = $upload_dir['path'];
        }
    ?>
    <div class="wrap">
    <div id="icon-options-general" class="icon32"><br /></div>
        <h2><?php echo TBP_GULP_PLUGIN_NAME; ?></h2>
    <div id="poststuff" class="metabox-holder">
      <div id="post-body-content" class="">
        <div class="postbox">
        <h3 class="hndle"><span>Upload ZIP File</span></h3>
        <div class="inside">
        <p>Click Browse to get the ZIP file you want to upload, then click Upload</p>        
<form action="<?php echo $_SERVER['REQUEST_URI']; ?>" method="POST" enctype="multipart/form-data">            
  <label for="zip">Upload Zip
  </label>            
  <input type="file" name="zip" />
  <p>
    <input type="submit" class="button-primary" value="Upload Zip for Processing" />
  </p>
</form>
        </div>
      </div>
    </div>
    </div>
    </div>
<?php
}
  // Register Custom Post Type Imported Article
function create_importedarticle_cpt() {

  $labels = array(
    'name' => _x( 'Imported Articles', 'Post Type General Name', 'textdomain' ),
    'singular_name' => _x( 'Imported Articles', 'Post Type Singular Name', 'textdomain' ),
    'menu_name' => _x( 'Imported Articles', 'Admin Menu text', 'textdomain' ),
    'name_admin_bar' => _x( 'Imported Articles', 'Add New on Toolbar', 'textdomain' ),
    'archives' => __( 'Imported Article Archives', 'textdomain' ),
    'attributes' => __( 'Imported Article Attributes', 'textdomain' ),
    'parent_item_colon' => __( 'Parent Imported Article:', 'textdomain' ),
    'all_items' => __( 'All Imported Article', 'textdomain' ),
    'add_new_item' => __( 'Add New Imported Article', 'textdomain' ),
    'add_new' => __( 'Add New', 'textdomain' ),
    'new_item' => __( 'New Imported Article', 'textdomain' ),
    'edit_item' => __( 'Edit Imported Article', 'textdomain' ),
    'update_item' => __( 'Update Imported Article', 'textdomain' ),
    'view_item' => __( 'View Imported Article', 'textdomain' ),
    'view_items' => __( 'View Imported Article', 'textdomain' ),
    'search_items' => __( 'Search Imported Article', 'textdomain' ),
    'not_found' => __( 'Not found', 'textdomain' ),
    'not_found_in_trash' => __( 'Not found in Trash', 'textdomain' ),
    'featured_image' => __( 'Featured Image', 'textdomain' ),
    'set_featured_image' => __( 'Set featured image', 'textdomain' ),
    'remove_featured_image' => __( 'Remove featured image', 'textdomain' ),
    'use_featured_image' => __( 'Use as featured image', 'textdomain' ),
    'insert_into_item' => __( 'Insert into Imported Article', 'textdomain' ),
    'uploaded_to_this_item' => __( 'Uploaded to this Imported Article', 'textdomain' ),
    'items_list' => __( 'Imported Article list', 'textdomain' ),
    'items_list_navigation' => __( 'Imported Article list navigation', 'textdomain' ),
    'filter_items_list' => __( 'Filter Imported Article list', 'textdomain' ),
  );
  $args = array(
    'label' => __( 'Imported Articles', 'textdomain' ),
    'description' => __( '', 'textdomain' ),
    'labels' => $labels,
    'menu_icon' => '',
    'supports' => array('title'),
    'taxonomies' => array(),
    'public' => true,
    'show_ui' => true,
    'show_in_menu' => false,
    'menu_position' => 5,
    'show_in_admin_bar' => false,
    'show_in_nav_menus' => false,
    'can_export' => false,
    'has_archive' => false,
    'hierarchical' => false,
    'exclude_from_search' => false,
    'show_in_rest' => true,
    'publicly_queryable' => false,
    'capability_type' => 'post',
  );
  register_post_type( 'importedarticle', $args );

}
add_action( 'init', 'create_importedarticle_cpt', 0 );
function disable_new_posts() {
// Hide sidebar link
global $submenu;
unset($submenu['edit.php?post_type=importedarticle'][10]);

// Hide link on listing page
if (isset($_GET['post_type']) && $_GET['post_type'] == 'importedarticle') {
    echo '<style type="text/css">#favorite-actions, .add-new-h2, .tablenav, .page-title-action,.subsubsub,.search-box, .check-column { display:none !important; }</style>';
}
}
add_action('admin_menu', 'disable_new_posts', 20);

add_filter( 'manage_importedarticle_posts_columns', 'set_custom_edit_importedarticle_columns' );
function set_custom_edit_importedarticle_columns($columns) {
    unset( $columns['date'] );
    unset( $columns['title'] );
    // $columns['product_id'] = __( 'Product ID', 'ddpp' );
    $columns['zip'] = __( 'ZIP File Name', 'ddpp' );
    $columns['date_'] = __( 'Date Imported', 'ddpp' );
    $columns['total'] = __( 'Total Articles', 'ddpp' );
    $columns['imported'] = __( 'Articles Imported', 'ddpp' );
    $columns['remaining'] = __( 'Articles Remaining', 'ddpp' );

    return $columns;
}

function importedarticle_duplicate_post_link($actions, $post)
{
    if ($post->post_type=='importedarticle')
    {
      unset($actions['inline hide-if-no-js']);
      unset($actions['view']);
      unset($actions['edit']);
    }
    return $actions;
}
add_filter('post_row_actions', 'importedarticle_duplicate_post_link', 10, 2);

add_action( 'manage_importedarticle_posts_custom_column' , 'custom_importedarticle_column', 10, 2 );
function custom_importedarticle_column( $column, $post_id ) {
    switch ( $column ) {
        case 'zip' :
            echo get_the_title($post_id); 
            break;
        case 'date_' :
            echo get_the_date( 'd.m.Y H:i', $post_id ); 
            break;
        case 'total' :
            echo get_post_meta( $post_id , '_import_to_import' , true ); 
            break;
        case 'imported' :
            $imported = get_post_meta( $post_id , '_import_imported' , true );
            $errors = get_post_meta($post_id, '_import_errors', false);
            $error_text="<div style='display:none'>";
            if(count($errors)>0)
              foreach($errors as $error)
                $error_text.="$error<br>";
            $error_text.="</div>";
            if(count($errors)>0)
              echo $imported.' <span style="color: red" title="Errors" onclick=jQuery(this).next().toggle()>(incl. '.count($errors).' error(s))</span>'.$error_text; 
            else
              echo $imported;
            break;
        case 'remaining' :
            echo (get_post_meta( $post_id , '_import_to_import' , true )-get_post_meta( $post_id , '_import_imported' , true )); 
            break;

    }
}